public class Grille {
    private final int sizeX, sizeY;
    private final Case[][] grille;

    Grille(int x, int y) {
        this.sizeX = x;
        this.sizeY = y;
        grille = new Case[y][x];
    }

    public void setCase(Case item, int x, int y) {
        grille[y][x] = item;
    }

    /**
     * fonction permetant d'affecter une valeur à une case en cour de jeu
     * @param val valeur à affecter
     * @param x position en x
     * @param y position en y
     * @return si l'affectation à eu lieu
     */
    public boolean setVal(int val, int x, int y) {
        if (grille[y][x].getType_case() == 3 && checkLeft(val, x, y) && checkTop(val, x, y)) {
            grille[y][x].setVal(val);
            return true;
        }
        else {
            return false;
        }
    }

    public boolean checkLeft(int val, int x, int y) {
        while (grille[y][x].getType_case() != 1) {
            x = x-1;
        }
        return grille[y][x].getVal() <= val;
    }

    public boolean checkTop(int val, int x, int y) {
        while (grille[y][x].getType_case() != 1 && y <= 0) {
            y = y-1;
        }
        return grille[y][x].getVal() <= val;
    }

    public int getSizeX() {
        return this.sizeX;
    }

    public int getSizeY() {
        return this.sizeY;
    }

    public Case getCase(int x, int y) {
        return this.grille[y][x];
    }
}
