import java.io.*;
import java.nio.charset.Charset;

/**
 * méthode créant la grille de jeux
 * comme internet ne sait pas comment fonctionne readline le contenue du tableau n'est pas encore définitif
 */
public class Jeu {
    String[] pathLvl = {"Path LVL 1", "Path LVL 2", "Path LVL 3"};

    public Grille creerGrille(int lvl) throws IOException {
        int[][] grilleInit;

        File file = new File(pathLvl[lvl]);

        try (BufferedReader reader = new BufferedReader(new FileReader(file))) {
            String text = null;
            while ((text = reader.readLine()) != null) {
                grilleInit.add(Integer.parseInt(text));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        /*
        Charset encoding = Charset.defaultCharset();
        File loaderGrille = new File(pathLvl[lvl]);
        try (InputStream in = new FileInputStream(loaderGrille);
             Reader reader = new InputStreamReader(in, encoding);
             Reader buffer = new BufferedReader(reader)) {
            int[] r;
            int cont = 0;
            //readLine lit une ligne et cree un tableau du contenu (notmalement ><)
            while ((r = reader.readLine()) != -1) {
                grilleInit[cont] = r;
                cont++;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } */

        return initGrille(grilleInit);
    }

    /**
     * Initialise la grille depuis un tableau obtenue depuis une fichier
     * grilleInit[0] contient la taille du tableau, le reste contient les cases (1 par lignes)
     * grilleInit[i][0] contient le type de la case
     * grilleInit[i][1] contient l'indice en x
     * grilleInit[i][2] contient l'indice en y
     * grilleInit[i][3](et [4]) contient la/les valeurs de la cases
     * @param grilleInit tableau d'initialisation
     */
    public Grille initGrille(int[][] grilleInit) {
        Grille grilleJeu = new Grille(grilleInit[0][1] ,grilleInit[0][0]);

        for (int i = 1; i < grilleInit.length;i++) {
            switch (grilleInit[i][0]) {
                case 1 -> grilleJeu.setCase(new Case_indication(grilleInit[i][3], grilleInit[i][4]), grilleInit[i][1], grilleInit[i][2]);
                case 2 -> grilleJeu.setCase(new Case_static(grilleInit[i][3]), grilleInit[i][1], grilleInit[i][2]);
            }
        }

        boolean vide = true;
        for (int i = 0; i < grilleJeu.getSizeY(); i++) {
            for (int j = 0; j < grilleJeu.getSizeX(); j++) {
                if (grilleJeu.getCase(j,i).getClass() == Case.class) {
                    if (vide) grilleJeu.setCase(new Case(),j,i);
                    else grilleJeu.setCase(new Case_jouable(),j,i);
                }

                if (grilleJeu.getCase(j,i).getClass() == Case_indication.class && grilleJeu.getCase(j,i).getValY() != 0) vide = false;
                else if (grilleJeu.getCase(j,i).getClass() == Case_indication.class) vide = true;
            }
        }
        return grilleJeu;
    }

    public boolean checkColumn(int x, Grille grille) {
        int val = 0;
        for (int i = grille.getSizeY(); i >= 0; i--) {
            if (grille.getCase(x,i).getType_case() == 3 || grille.getCase(x,i).getType_case() == 2) {
                val += grille.getCase(x,i).getVal();
            }

            if (grille.getCase(x,i).getType_case() == 1) {
                if (val != grille.getCase(x,i).getValX()) {
                    return false;
                    }
                else {
                    val = 0;
                }
            }
        }
        return true;
    }

    public boolean checkLine(int y, Grille grille) {
        int val = 0;
        for (int i = grille.getSizeX(); i >= 0; i--) {
            if (grille.getCase(i,y).getType_case() == 3 || grille.getCase(i,y).getType_case() == 2) {
                val += grille.getCase(i,y).getVal();
            }

            if (grille.getCase(i,y).getType_case() == 1) {
                if (val != grille.getCase(i,y).getValY()) {
                    return false;
                }
                else {
                    val = 0;
                }
            }
        }
        return true;
    }

    public boolean chekGrid(Grille grille) {
        for (int i = 0; i < grille.getSizeX(); i++) {
            if (!checkLine(i, grille)) return false;
        }

        for (int i = 0; i < grille.getSizeY(); i++) {
            if (!checkColumn(i, grille)) return false;
        }

        return true;
    }
}
